org.apache.fop.util

## Class AbstractPaintingState.AbstractData

- java.lang.Object
- - org.apache.fop.util.AbstractPaintingState.AbstractData

All Implemented Interfaces:
  Serializable, Cloneable

Enclosing class:
  AbstractPaintingState

    public abstract class AbstractPaintingState.AbstractData
    extends Object
    implements Cloneable, Serializable

A base painting state data holding object

See Also:
  Serialized Form

### Field Summary

Fields
`protected Color` `backColor` The current background color
`protected Color` `color` The current color
`protected float[]` `dashArray` The dash array for the current basic stroke (line type)
`protected String` `fontName` The current font name
`protected int` `fontSize` The current font size
`protected String` `layer` The current (optional content group) layer.
`protected float` `lineWidth` The current line width
`protected AffineTransform` `transform` The current transform

### Constructor Summary

Constructors
Constructor and Description
`AbstractData()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`void` `clearTransform()` Resets the current AffineTransform.
`Object` `clone()`
`void` `concatenate(AffineTransform at)` Concatenate the given AffineTransform with the current thus creating a new viewport.
`int` `getDerivedRotation()` Returns the derived rotation from the current transform
`String` `getLayer()`
`AffineTransform` `getTransform()` Get the current AffineTransform.
`protected abstract AbstractPaintingState.AbstractData` `instantiate()` Returns a newly create data object
`void` `setLayer(String layer)`
`void` `setTransform(AffineTransform baseTransform)` Sets the current AffineTransform.
`String` `toString()`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### color

    protected Color color

The current color

#### backColor

    protected Color backColor

The current background color

#### fontName

    protected String fontName

The current font name

#### fontSize

    protected int fontSize

The current font size

#### lineWidth

    protected float lineWidth

The current line width

#### dashArray

    protected float[] dashArray

The dash array for the current basic stroke (line type)

#### transform

    protected AffineTransform transform

The current transform

#### layer

    protected String layer

The current (optional content group) layer.

### Constructor Detail

#### AbstractData

    public AbstractData()

### Method Detail

#### instantiate

    protected abstract AbstractPaintingState.AbstractData instantiate()

Returns a newly create data object

Returns:
  a new data object

#### concatenate

    public void concatenate(AffineTransform at)

Concatenate the given AffineTransform with the current thus creating a new viewport. Note that all concatenation operations are logged so they can be replayed if necessary (ex. for block-containers with "fixed" positioning.

Parameters:
  `at` - Transformation to perform

#### getTransform

    public AffineTransform getTransform()

Get the current AffineTransform.

Returns:
  the current transform

#### setTransform

    public void setTransform(AffineTransform baseTransform)

Sets the current AffineTransform.

Parameters:
  `baseTransform` - the transform

#### clearTransform

    public void clearTransform()

Resets the current AffineTransform.

#### setLayer

    public void setLayer(String layer)

#### getLayer

    public String getLayer()

#### getDerivedRotation

    public int getDerivedRotation()

Returns the derived rotation from the current transform

Returns:
  the derived rotation from the current transform

#### clone

    public Object clone()

Overrides:
  `clone` in class `Object`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`